<template>

    <Container :max-height="maxHeight" max-width="max-width" class="column full-width items-center">
        <div class="col-8">
            <LottieHover :initial-play="true" :data="animation" class="full-height"/>
        </div>
        <div class="col-1 text-h6 text-weight-thin q-mx-auto">
            {{ text }}
        </div>
        <q-expansion-item icon="icofont-warning" label="Error Details" class="shadow-1 overflow-hidden"
                          style="border-radius: 5px" header-class="bg-negative text-white">
            <q-card>
                <q-card-section v-for="(e,i) in Errors" :key="i">
                    {{ e }}
                    <q-separator v-if="i !== Errors.length-1"/>
                </q-card-section>
            </q-card>
        </q-expansion-item>
    </Container>
</template>


<script lang="ts">
import {Component, Prop, Vue} from 'vue-property-decorator';
import LottieAnimation from "components/Core/LottieAnimation.vue";
import Container from "components/Core/Container.vue";
import LottieHover from "components/Core/LottieHover.vue";

@Component({
    components: {LottieHover, Container, LottieAnimation}
})
export default class ErrorComponent extends Vue {
    @Prop() animation!: object
    @Prop() text!: string;
    @Prop({default: undefined}) maxHeight?: boolean | number;
    @Prop({default: undefined}) maxWidth?: boolean | number;
    @Prop({default: ['no error details']}) errorDetail!: string | string[];

    get Errors(): string[] {
        if (typeof this.errorDetail === "string") {
            return [this.errorDetail];
        }
        return this.errorDetail;
    }
}
</script>
